#include <pluginlib/class_list_macros.h>
#include <ros/ros.h>

#include "mainNode/mainNode.h"

#include "car/camDataMsg.h"
#include "car/ccDataMsg.h"
#include "car/environmentDataMsg.h"
#include "car/logEnabledMsg.h"
#include "car/logStringMsg.h"
#include "car/rcEnabledMsg.h"
#include "car/stmDataMsg.h"
#include "car/ussDataMsg.h"

PLUGINLIB_EXPORT_CLASS(car::MainNode, nodelet::Nodelet);

namespace car
{
MainNode::MainNode(ros::NodeHandle & nh, std::string & name) :
    platoonController()
    , platoonControllerThread([this] { platoonController.run(); })
 // , c2cNet()
 // , pcNet()
 // , c2c()
 // , commandReceiver(pc2car::CommandReceiver::create(pcNet))
    , nh(nh)  
    , name(name)
{
  std::cout << "Called MainNode(ros::NodeHandle & nh, std::string & name)." << std::endl;
}

MainNode::MainNode() : 
    platoonController()
    , platoonControllerThread([this] { platoonController.run(); })
 // , c2cNet()
 // , pcNet()
 // , c2c()
 // , commandReceiver(pc2car::CommandReceiver::create(pcNet))
{
  std::cout << "Called MainNode()." << std::endl;
}

MainNode::~MainNode()
{}

void MainNode::onInit()
{
    NODELET_INFO("MainNode::onInit -- START");
    logEnabled = nh.advertise<logEnabledMsg>("logEnabled", 5);
    environmentData = nh.subscribe("environmentData", 1, &MainNode::environmentDataCallback, this);

    // CODE GOES HERE

    NODELET_INFO("MainNode::onInit -- END");
}

void MainNode::environmentDataCallback(const environmentDataMsg::ConstPtr & inMsg)
{
    std::cout << "MainNode recived new environmentData data (" << inMsg->distance << ", " << inMsg->prevSpeed << ").\n";
}
}
